<!doctype html>
<html lang="en">
 <head> 
  <meta charset="UTF-8"> 
  <meta http-equiv="X-UA-Compatible" content="IE=edge"> 
  <meta name="robots" content="noindex"> 
  <meta name="viewport" content="width=device-width, initial-scale=1.0"> 
  <meta name="generator" content="Asciidoctor 2.0.12"> 
  <meta name="author" content="Copyright (c) 2010, 2022 Contributors to the Eclipse Foundation"> 
  <title>Customizing output | Eclipse ESCET™ development documentation (Incubation)</title> 
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans:300,300italic,400,400italic,600,600italic%7CNoto+Serif:400,400italic,700,700italic%7CDroid+Sans+Mono:400,700"> 
  <style>
/* Asciidoctor default stylesheet | MIT License | https://asciidoctor.org */
/* Uncomment @import statement to use as custom stylesheet */
/*@import "https://fonts.googleapis.com/css?family=Open+Sans:300,300italic,400,400italic,600,600italic%7CNoto+Serif:400,400italic,700,700italic%7CDroid+Sans+Mono:400,700";*/
article,aside,details,figcaption,figure,footer,header,hgroup,main,nav,section{display:block}
audio,video{display:inline-block}
audio:not([controls]){display:none;height:0}
html{font-family:sans-serif;-ms-text-size-adjust:100%;-webkit-text-size-adjust:100%}
a{background:none}
a:focus{outline:thin dotted}
a:active,a:hover{outline:0}
h1{font-size:2em;margin:.67em 0}
abbr[title]{border-bottom:1px dotted}
b,strong{font-weight:bold}
dfn{font-style:italic}
hr{-moz-box-sizing:content-box;box-sizing:content-box;height:0}
mark{background:#ff0;color:#000}
code,kbd,pre,samp{font-family:monospace;font-size:1em}
pre{white-space:pre-wrap}
q{quotes:"\201C" "\201D" "\2018" "\2019"}
small{font-size:80%}
sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}
sup{top:-.5em}
sub{bottom:-.25em}
img{border:0}
svg:not(:root){overflow:hidden}
figure{margin:0}
fieldset{border:1px solid silver;margin:0 2px;padding:.35em .625em .75em}
legend{border:0;padding:0}
button,input,select,textarea{font-family:inherit;font-size:100%;margin:0}
button,input{line-height:normal}
button,select{text-transform:none}
button,html input[type="button"],input[type="reset"],input[type="submit"]{-webkit-appearance:button;cursor:pointer}
button[disabled],html input[disabled]{cursor:default}
input[type="checkbox"],input[type="radio"]{box-sizing:border-box;padding:0}
button::-moz-focus-inner,input::-moz-focus-inner{border:0;padding:0}
textarea{overflow:auto;vertical-align:top}
table{border-collapse:collapse;border-spacing:0}
*,*::before,*::after{-moz-box-sizing:border-box;-webkit-box-sizing:border-box;box-sizing:border-box}
html,body{font-size:100%}
body{background:#fff;color:rgba(0,0,0,.8);padding:0;margin:0;font-family:"Noto Serif","DejaVu Serif",serif;font-weight:400;font-style:normal;line-height:1;position:relative;cursor:auto;tab-size:4;word-wrap:anywhere;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased}
a:hover{cursor:pointer}
img,object,embed{max-width:100%;height:auto}
object,embed{height:100%}
img{-ms-interpolation-mode:bicubic}
.left{float:left!important}
.right{float:right!important}
.text-left{text-align:left!important}
.text-right{text-align:right!important}
.text-center{text-align:center!important}
.text-justify{text-align:justify!important}
.hide{display:none}
img,object,svg{display:inline-block;vertical-align:middle}
textarea{height:auto;min-height:50px}
select{width:100%}
.subheader,.admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{line-height:1.45;color:#7a2518;font-weight:400;margin-top:0;margin-bottom:.25em}
div,dl,dt,dd,ul,ol,li,h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6,pre,form,p,blockquote,th,td{margin:0;padding:0}
a{color:#2156a5;text-decoration:underline;line-height:inherit}
a:hover,a:focus{color:#1d4b8f}
a img{border:0}
p{font-family:inherit;font-weight:400;font-size:1em;line-height:1.6;margin-bottom:1.25em;text-rendering:optimizeLegibility}
p aside{font-size:.875em;line-height:1.35;font-style:italic}
h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{font-family:"Open Sans","DejaVu Sans",sans-serif;font-weight:300;font-style:normal;color:#ba3925;text-rendering:optimizeLegibility;margin-top:1em;margin-bottom:.5em;line-height:1.0125em}
h1 small,h2 small,h3 small,#toctitle small,.sidebarblock>.content>.title small,h4 small,h5 small,h6 small{font-size:60%;color:#e99b8f;line-height:0}
h1{font-size:2.125em}
h2{font-size:1.6875em}
h3,#toctitle,.sidebarblock>.content>.title{font-size:1.375em}
h4,h5{font-size:1.125em}
h6{font-size:1em}
hr{border:solid #dddddf;border-width:1px 0 0;clear:both;margin:1.25em 0 1.1875em;height:0}
em,i{font-style:italic;line-height:inherit}
strong,b{font-weight:bold;line-height:inherit}
small{font-size:60%;line-height:inherit}
code{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;font-weight:400;color:rgba(0,0,0,.9)}
ul,ol,dl{font-size:1em;line-height:1.6;margin-bottom:1.25em;list-style-position:outside;font-family:inherit}
ul,ol{margin-left:1.5em}
ul li ul,ul li ol{margin-left:1.25em;margin-bottom:0;font-size:1em}
ul.square li ul,ul.circle li ul,ul.disc li ul{list-style:inherit}
ul.square{list-style-type:square}
ul.circle{list-style-type:circle}
ul.disc{list-style-type:disc}
ol li ul,ol li ol{margin-left:1.25em;margin-bottom:0}
dl dt{margin-bottom:.3125em;font-weight:bold}
dl dd{margin-bottom:1.25em}
abbr,acronym{text-transform:uppercase;font-size:90%;color:rgba(0,0,0,.8);border-bottom:1px dotted #ddd;cursor:help}
abbr{text-transform:none}
blockquote{margin:0 0 1.25em;padding:.5625em 1.25em 0 1.1875em;border-left:1px solid #ddd}
blockquote cite{display:block;font-size:.9375em;color:rgba(0,0,0,.6)}
blockquote cite::before{content:"\2014 \0020"}
blockquote cite a,blockquote cite a:visited{color:rgba(0,0,0,.6)}
blockquote,blockquote p{line-height:1.6;color:rgba(0,0,0,.85)}
@media screen and (min-width:768px){h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2}
h1{font-size:2.75em}
h2{font-size:2.3125em}
h3,#toctitle,.sidebarblock>.content>.title{font-size:1.6875em}
h4{font-size:1.4375em}}
table{background:#fff;margin-bottom:1.25em;border:solid 1px #dedede;word-wrap:normal}
table thead,table tfoot{background:#f7f8f7}
table thead tr th,table thead tr td,table tfoot tr th,table tfoot tr td{padding:.5em .625em .625em;font-size:inherit;color:rgba(0,0,0,.8);text-align:left}
table tr th,table tr td{padding:.5625em .625em;font-size:inherit;color:rgba(0,0,0,.8)}
table tr.even,table tr.alt{background:#f8f8f7}
table thead tr th,table tfoot tr th,table tbody tr td,table tr td,table tfoot tr td{line-height:1.6}
h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2;word-spacing:-.05em}
h1 strong,h2 strong,h3 strong,#toctitle strong,.sidebarblock>.content>.title strong,h4 strong,h5 strong,h6 strong{font-weight:400}
.center{margin-left:auto;margin-right:auto}
.stretch{width:100%}
.clearfix::before,.clearfix::after,.float-group::before,.float-group::after{content:" ";display:table}
.clearfix::after,.float-group::after{clear:both}
:not(pre).nobreak{word-wrap:normal}
:not(pre).nowrap{white-space:nowrap}
:not(pre).pre-wrap{white-space:pre-wrap}
:not(pre):not([class^=L])>code{font-size:.9375em;font-style:normal!important;letter-spacing:0;padding:.1em .5ex;word-spacing:-.15em;background:#f7f7f8;-webkit-border-radius:4px;border-radius:4px;line-height:1.45;text-rendering:optimizeSpeed}
pre{color:rgba(0,0,0,.9);font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;line-height:1.45;text-rendering:optimizeSpeed}
pre code,pre pre{color:inherit;font-size:inherit;line-height:inherit}
pre>code{display:block}
pre.nowrap,pre.nowrap pre{white-space:pre;word-wrap:normal}
em em{font-style:normal}
strong strong{font-weight:400}
.keyseq{color:rgba(51,51,51,.8)}
kbd{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;display:inline-block;color:rgba(0,0,0,.8);font-size:.65em;line-height:1.45;background:#f7f7f7;border:1px solid #ccc;-webkit-border-radius:3px;border-radius:3px;-webkit-box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em white inset;box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em #fff inset;margin:0 .15em;padding:.2em .5em;vertical-align:middle;position:relative;top:-.1em;white-space:nowrap}
.keyseq kbd:first-child{margin-left:0}
.keyseq kbd:last-child{margin-right:0}
.menuseq,.menuref{color:#000}
.menuseq b:not(.caret),.menuref{font-weight:inherit}
.menuseq{word-spacing:-.02em}
.menuseq b.caret{font-size:1.25em;line-height:.8}
.menuseq i.caret{font-weight:bold;text-align:center;width:.45em}
b.button::before,b.button::after{position:relative;top:-1px;font-weight:400}
b.button::before{content:"[";padding:0 3px 0 2px}
b.button::after{content:"]";padding:0 2px 0 3px}
p a>code:hover{color:rgba(0,0,0,.9)}
#header,#content,#footnotes,#footer{width:100%;margin-left:auto;margin-right:auto;margin-top:0;margin-bottom:0;max-width:62.5em;*zoom:1;position:relative;padding-left:.9375em;padding-right:.9375em}
#header::before,#header::after,#content::before,#content::after,#footnotes::before,#footnotes::after,#footer::before,#footer::after{content:" ";display:table}
#header::after,#content::after,#footnotes::after,#footer::after{clear:both}
#content{margin-top:1.25em}
#content::before{content:none}
#header>h1:first-child{color:rgba(0,0,0,.85);margin-top:2.25rem;margin-bottom:0}
#header>h1:first-child+#toc{margin-top:8px;border-top:1px solid #dddddf}
#header>h1:only-child,body.toc2 #header>h1:nth-last-child(2){border-bottom:1px solid #dddddf;padding-bottom:8px}
#header .details{border-bottom:1px solid #dddddf;line-height:1.45;padding-top:.25em;padding-bottom:.25em;padding-left:.25em;color:rgba(0,0,0,.6);display:-ms-flexbox;display:-webkit-flex;display:flex;-ms-flex-flow:row wrap;-webkit-flex-flow:row wrap;flex-flow:row wrap}
#header .details span:first-child{margin-left:-.125em}
#header .details span.email a{color:rgba(0,0,0,.85)}
#header .details br{display:none}
#header .details br+span::before{content:"\00a0\2013\00a0"}
#header .details br+span.author::before{content:"\00a0\22c5\00a0";color:rgba(0,0,0,.85)}
#header .details br+span#revremark::before{content:"\00a0|\00a0"}
#header #revnumber{text-transform:capitalize}
#header #revnumber::after{content:"\00a0"}
#content>h1:first-child:not([class]){color:rgba(0,0,0,.85);border-bottom:1px solid #dddddf;padding-bottom:8px;margin-top:0;padding-top:1rem;margin-bottom:1.25rem}
#toc{border-bottom:1px solid #e7e7e9;padding-bottom:.5em}
#toc>ul{margin-left:.125em}
#toc ul.sectlevel0>li>a{font-style:italic}
#toc ul.sectlevel0 ul.sectlevel1{margin:.5em 0}
#toc ul{font-family:"Open Sans","DejaVu Sans",sans-serif;list-style-type:none}
#toc li{line-height:1.3334;margin-top:.3334em}
#toc a{text-decoration:none}
#toc a:active{text-decoration:underline}
#toctitle{color:#7a2518;font-size:1.2em}
@media screen and (min-width:768px){#toctitle{font-size:1.375em}
body.toc2{padding-left:15em;padding-right:0}
#toc.toc2{margin-top:0!important;background:#f8f8f7;position:fixed;width:15em;left:0;top:0;border-right:1px solid #e7e7e9;border-top-width:0!important;border-bottom-width:0!important;z-index:1000;padding:1.25em 1em;height:100%;overflow:auto}
#toc.toc2 #toctitle{margin-top:0;margin-bottom:.8rem;font-size:1.2em}
#toc.toc2>ul{font-size:.9em;margin-bottom:0}
#toc.toc2 ul ul{margin-left:0;padding-left:1em}
#toc.toc2 ul.sectlevel0 ul.sectlevel1{padding-left:0;margin-top:.5em;margin-bottom:.5em}
body.toc2.toc-right{padding-left:0;padding-right:15em}
body.toc2.toc-right #toc.toc2{border-right-width:0;border-left:1px solid #e7e7e9;left:auto;right:0}}
@media screen and (min-width:1280px){body.toc2{padding-left:20em;padding-right:0}
#toc.toc2{width:20em}
#toc.toc2 #toctitle{font-size:1.375em}
#toc.toc2>ul{font-size:.95em}
#toc.toc2 ul ul{padding-left:1.25em}
body.toc2.toc-right{padding-left:0;padding-right:20em}}
#content #toc{border-style:solid;border-width:1px;border-color:#e0e0dc;margin-bottom:1.25em;padding:1.25em;background:#f8f8f7;-webkit-border-radius:4px;border-radius:4px}
#content #toc>:first-child{margin-top:0}
#content #toc>:last-child{margin-bottom:0}
#footer{max-width:none;background:rgba(0,0,0,.8);padding:1.25em}
#footer-text{color:rgba(255,255,255,.8);line-height:1.44}
#content{margin-bottom:.625em}
.sect1{padding-bottom:.625em}
@media screen and (min-width:768px){#content{margin-bottom:1.25em}
.sect1{padding-bottom:1.25em}}
.sect1:last-child{padding-bottom:0}
.sect1+.sect1{border-top:1px solid #e7e7e9}
#content h1>a.anchor,h2>a.anchor,h3>a.anchor,#toctitle>a.anchor,.sidebarblock>.content>.title>a.anchor,h4>a.anchor,h5>a.anchor,h6>a.anchor{position:absolute;z-index:1001;width:1.5ex;margin-left:-1.5ex;display:block;text-decoration:none!important;visibility:hidden;text-align:center;font-weight:400}
#content h1>a.anchor::before,h2>a.anchor::before,h3>a.anchor::before,#toctitle>a.anchor::before,.sidebarblock>.content>.title>a.anchor::before,h4>a.anchor::before,h5>a.anchor::before,h6>a.anchor::before{content:"\00A7";font-size:.85em;display:block;padding-top:.1em}
#content h1:hover>a.anchor,#content h1>a.anchor:hover,h2:hover>a.anchor,h2>a.anchor:hover,h3:hover>a.anchor,#toctitle:hover>a.anchor,.sidebarblock>.content>.title:hover>a.anchor,h3>a.anchor:hover,#toctitle>a.anchor:hover,.sidebarblock>.content>.title>a.anchor:hover,h4:hover>a.anchor,h4>a.anchor:hover,h5:hover>a.anchor,h5>a.anchor:hover,h6:hover>a.anchor,h6>a.anchor:hover{visibility:visible}
#content h1>a.link,h2>a.link,h3>a.link,#toctitle>a.link,.sidebarblock>.content>.title>a.link,h4>a.link,h5>a.link,h6>a.link{color:#ba3925;text-decoration:none}
#content h1>a.link:hover,h2>a.link:hover,h3>a.link:hover,#toctitle>a.link:hover,.sidebarblock>.content>.title>a.link:hover,h4>a.link:hover,h5>a.link:hover,h6>a.link:hover{color:#a53221}
details,.audioblock,.imageblock,.literalblock,.listingblock,.stemblock,.videoblock{margin-bottom:1.25em}
details>summary:first-of-type{cursor:pointer;display:list-item;outline:none;margin-bottom:.75em}
.admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{text-rendering:optimizeLegibility;text-align:left;font-family:"Noto Serif","DejaVu Serif",serif;font-size:1rem;font-style:italic}
table.tableblock.fit-content>caption.title{white-space:nowrap;width:0}
.paragraph.lead>p,#preamble>.sectionbody>[class="paragraph"]:first-of-type p{font-size:1.21875em;line-height:1.6;color:rgba(0,0,0,.85)}
table.tableblock #preamble>.sectionbody>[class="paragraph"]:first-of-type p{font-size:inherit}
.admonitionblock>table{border-collapse:separate;border:0;background:none;width:100%}
.admonitionblock>table td.icon{text-align:center;width:80px}
.admonitionblock>table td.icon img{max-width:none}
.admonitionblock>table td.icon .title{font-weight:bold;font-family:"Open Sans","DejaVu Sans",sans-serif;text-transform:uppercase}
.admonitionblock>table td.content{padding-left:1.125em;padding-right:1.25em;border-left:1px solid #dddddf;color:rgba(0,0,0,.6);word-wrap:anywhere}
.admonitionblock>table td.content>:last-child>:last-child{margin-bottom:0}
.exampleblock>.content{border-style:solid;border-width:1px;border-color:#e6e6e6;margin-bottom:1.25em;padding:1.25em;background:#fff;-webkit-border-radius:4px;border-radius:4px}
.exampleblock>.content>:first-child{margin-top:0}
.exampleblock>.content>:last-child{margin-bottom:0}
.sidebarblock{border-style:solid;border-width:1px;border-color:#dbdbd6;margin-bottom:1.25em;padding:1.25em;background:#f3f3f2;-webkit-border-radius:4px;border-radius:4px}
.sidebarblock>:first-child{margin-top:0}
.sidebarblock>:last-child{margin-bottom:0}
.sidebarblock>.content>.title{color:#7a2518;margin-top:0;text-align:center}
.exampleblock>.content>:last-child>:last-child,.exampleblock>.content .olist>ol>li:last-child>:last-child,.exampleblock>.content .ulist>ul>li:last-child>:last-child,.exampleblock>.content .qlist>ol>li:last-child>:last-child,.sidebarblock>.content>:last-child>:last-child,.sidebarblock>.content .olist>ol>li:last-child>:last-child,.sidebarblock>.content .ulist>ul>li:last-child>:last-child,.sidebarblock>.content .qlist>ol>li:last-child>:last-child{margin-bottom:0}
.literalblock pre,.listingblock>.content>pre{-webkit-border-radius:4px;border-radius:4px;overflow-x:auto;padding:1em;font-size:.8125em}
@media screen and (min-width:768px){.literalblock pre,.listingblock>.content>pre{font-size:.90625em}}
@media screen and (min-width:1280px){.literalblock pre,.listingblock>.content>pre{font-size:1em}}
.literalblock pre,.listingblock>.content>pre:not(.highlight),.listingblock>.content>pre[class="highlight"],.listingblock>.content>pre[class^="highlight "]{background:#f7f7f8}
.literalblock.output pre{color:#f7f7f8;background:rgba(0,0,0,.9)}
.listingblock>.content{position:relative}
.listingblock code[data-lang]::before{display:none;content:attr(data-lang);position:absolute;font-size:.75em;top:.425rem;right:.5rem;line-height:1;text-transform:uppercase;color:inherit;opacity:.5}
.listingblock:hover code[data-lang]::before{display:block}
.listingblock.terminal pre .command::before{content:attr(data-prompt);padding-right:.5em;color:inherit;opacity:.5}
.listingblock.terminal pre .command:not([data-prompt])::before{content:"$"}
.listingblock pre.highlightjs{padding:0}
.listingblock pre.highlightjs>code{padding:1em;-webkit-border-radius:4px;border-radius:4px}
.listingblock pre.prettyprint{border-width:0}
.prettyprint{background:#f7f7f8}
pre.prettyprint .linenums{line-height:1.45;margin-left:2em}
pre.prettyprint li{background:none;list-style-type:inherit;padding-left:0}
pre.prettyprint li code[data-lang]::before{opacity:1}
pre.prettyprint li:not(:first-child) code[data-lang]::before{display:none}
table.linenotable{border-collapse:separate;border:0;margin-bottom:0;background:none}
table.linenotable td[class]{color:inherit;vertical-align:top;padding:0;line-height:inherit;white-space:normal}
table.linenotable td.code{padding-left:.75em}
table.linenotable td.linenos{border-right:1px solid currentColor;opacity:.35;padding-right:.5em}
pre.pygments .lineno{border-right:1px solid currentColor;opacity:.35;display:inline-block;margin-right:.75em}
pre.pygments .lineno::before{content:"";margin-right:-.125em}
.quoteblock{margin:0 1em 1.25em 1.5em;display:table}
.quoteblock:not(.excerpt)>.title{margin-left:-1.5em;margin-bottom:.75em}
.quoteblock blockquote,.quoteblock p{color:rgba(0,0,0,.85);font-size:1.15rem;line-height:1.75;word-spacing:.1em;letter-spacing:0;font-style:italic;text-align:justify}
.quoteblock blockquote{margin:0;padding:0;border:0}
.quoteblock blockquote::before{content:"\201c";float:left;font-size:2.75em;font-weight:bold;line-height:.6em;margin-left:-.6em;color:#7a2518;text-shadow:0 1px 2px rgba(0,0,0,.1)}
.quoteblock blockquote>.paragraph:last-child p{margin-bottom:0}
.quoteblock .attribution{margin-top:.75em;margin-right:.5ex;text-align:right}
.verseblock{margin:0 1em 1.25em}
.verseblock pre{font-family:"Open Sans","DejaVu Sans",sans;font-size:1.15rem;color:rgba(0,0,0,.85);font-weight:300;text-rendering:optimizeLegibility}
.verseblock pre strong{font-weight:400}
.verseblock .attribution{margin-top:1.25rem;margin-left:.5ex}
.quoteblock .attribution,.verseblock .attribution{font-size:.9375em;line-height:1.45;font-style:italic}
.quoteblock .attribution br,.verseblock .attribution br{display:none}
.quoteblock .attribution cite,.verseblock .attribution cite{display:block;letter-spacing:-.025em;color:rgba(0,0,0,.6)}
.quoteblock.abstract blockquote::before,.quoteblock.excerpt blockquote::before,.quoteblock .quoteblock blockquote::before{display:none}
.quoteblock.abstract blockquote,.quoteblock.abstract p,.quoteblock.excerpt blockquote,.quoteblock.excerpt p,.quoteblock .quoteblock blockquote,.quoteblock .quoteblock p{line-height:1.6;word-spacing:0}
.quoteblock.abstract{margin:0 1em 1.25em;display:block}
.quoteblock.abstract>.title{margin:0 0 .375em;font-size:1.15em;text-align:center}
.quoteblock.excerpt>blockquote,.quoteblock .quoteblock{padding:0 0 .25em 1em;border-left:.25em solid #dddddf}
.quoteblock.excerpt,.quoteblock .quoteblock{margin-left:0}
.quoteblock.excerpt blockquote,.quoteblock.excerpt p,.quoteblock .quoteblock blockquote,.quoteblock .quoteblock p{color:inherit;font-size:1.0625rem}
.quoteblock.excerpt .attribution,.quoteblock .quoteblock .attribution{color:inherit;text-align:left;margin-right:0}
p.tableblock:last-child{margin-bottom:0}
td.tableblock>.content{margin-bottom:1.25em;word-wrap:anywhere}
td.tableblock>.content>:last-child{margin-bottom:-1.25em}
table.tableblock,th.tableblock,td.tableblock{border:0 solid #dedede}
table.grid-all>*>tr>*{border-width:1px}
table.grid-cols>*>tr>*{border-width:0 1px}
table.grid-rows>*>tr>*{border-width:1px 0}
table.frame-all{border-width:1px}
table.frame-ends{border-width:1px 0}
table.frame-sides{border-width:0 1px}
table.frame-none>colgroup+*>:first-child>*,table.frame-sides>colgroup+*>:first-child>*{border-top-width:0}
table.frame-none>:last-child>:last-child>*,table.frame-sides>:last-child>:last-child>*{border-bottom-width:0}
table.frame-none>*>tr>:first-child,table.frame-ends>*>tr>:first-child{border-left-width:0}
table.frame-none>*>tr>:last-child,table.frame-ends>*>tr>:last-child{border-right-width:0}
table.stripes-all tr,table.stripes-odd tr:nth-of-type(odd),table.stripes-even tr:nth-of-type(even),table.stripes-hover tr:hover{background:#f8f8f7}
th.halign-left,td.halign-left{text-align:left}
th.halign-right,td.halign-right{text-align:right}
th.halign-center,td.halign-center{text-align:center}
th.valign-top,td.valign-top{vertical-align:top}
th.valign-bottom,td.valign-bottom{vertical-align:bottom}
th.valign-middle,td.valign-middle{vertical-align:middle}
table thead th,table tfoot th{font-weight:bold}
tbody tr th{background:#f7f8f7}
tbody tr th,tbody tr th p,tfoot tr th,tfoot tr th p{color:rgba(0,0,0,.8);font-weight:bold}
p.tableblock>code:only-child{background:none;padding:0}
p.tableblock{font-size:1em}
ol{margin-left:1.75em}
ul li ol{margin-left:1.5em}
dl dd{margin-left:1.125em}
dl dd:last-child,dl dd:last-child>:last-child{margin-bottom:0}
ol>li p,ul>li p,ul dd,ol dd,.olist .olist,.ulist .ulist,.ulist .olist,.olist .ulist{margin-bottom:.625em}
ul.checklist,ul.none,ol.none,ul.no-bullet,ol.no-bullet,ol.unnumbered,ul.unstyled,ol.unstyled{list-style-type:none}
ul.no-bullet,ol.no-bullet,ol.unnumbered{margin-left:.625em}
ul.unstyled,ol.unstyled{margin-left:0}
ul.checklist{margin-left:.625em}
ul.checklist li>p:first-child>.fa-square-o:first-child,ul.checklist li>p:first-child>.fa-check-square-o:first-child{width:1.25em;font-size:.8em;position:relative;bottom:.125em}
ul.checklist li>p:first-child>input[type="checkbox"]:first-child{margin-right:.25em}
ul.inline{display:-ms-flexbox;display:-webkit-box;display:flex;-ms-flex-flow:row wrap;-webkit-flex-flow:row wrap;flex-flow:row wrap;list-style:none;margin:0 0 .625em -1.25em}
ul.inline>li{margin-left:1.25em}
.unstyled dl dt{font-weight:400;font-style:normal}
ol.arabic{list-style-type:decimal}
ol.decimal{list-style-type:decimal-leading-zero}
ol.loweralpha{list-style-type:lower-alpha}
ol.upperalpha{list-style-type:upper-alpha}
ol.lowerroman{list-style-type:lower-roman}
ol.upperroman{list-style-type:upper-roman}
ol.lowergreek{list-style-type:lower-greek}
.hdlist>table,.colist>table{border:0;background:none}
.hdlist>table>tbody>tr,.colist>table>tbody>tr{background:none}
td.hdlist1,td.hdlist2{vertical-align:top;padding:0 .625em}
td.hdlist1{font-weight:bold;padding-bottom:1.25em}
td.hdlist2{word-wrap:anywhere}
.literalblock+.colist,.listingblock+.colist{margin-top:-.5em}
.colist td:not([class]):first-child{padding:.4em .75em 0;line-height:1;vertical-align:top}
.colist td:not([class]):first-child img{max-width:none}
.colist td:not([class]):last-child{padding:.25em 0}
.thumb,.th{line-height:0;display:inline-block;border:solid 4px #fff;-webkit-box-shadow:0 0 0 1px #ddd;box-shadow:0 0 0 1px #ddd}
.imageblock.left{margin:.25em .625em 1.25em 0}
.imageblock.right{margin:.25em 0 1.25em .625em}
.imageblock>.title{margin-bottom:0}
.imageblock.thumb,.imageblock.th{border-width:6px}
.imageblock.thumb>.title,.imageblock.th>.title{padding:0 .125em}
.image.left,.image.right{margin-top:.25em;margin-bottom:.25em;display:inline-block;line-height:0}
.image.left{margin-right:.625em}
.image.right{margin-left:.625em}
a.image{text-decoration:none;display:inline-block}
a.image object{pointer-events:none}
sup.footnote,sup.footnoteref{font-size:.875em;position:static;vertical-align:super}
sup.footnote a,sup.footnoteref a{text-decoration:none}
sup.footnote a:active,sup.footnoteref a:active{text-decoration:underline}
#footnotes{padding-top:.75em;padding-bottom:.75em;margin-bottom:.625em}
#footnotes hr{width:20%;min-width:6.25em;margin:-.25em 0 .75em;border-width:1px 0 0}
#footnotes .footnote{padding:0 .375em 0 .225em;line-height:1.3334;font-size:.875em;margin-left:1.2em;margin-bottom:.2em}
#footnotes .footnote a:first-of-type{font-weight:bold;text-decoration:none;margin-left:-1.05em}
#footnotes .footnote:last-of-type{margin-bottom:0}
#content #footnotes{margin-top:-.625em;margin-bottom:0;padding:.75em 0}
.gist .file-data>table{border:0;background:#fff;width:100%;margin-bottom:0}
.gist .file-data>table td.line-data{width:99%}
div.unbreakable{page-break-inside:avoid}
.big{font-size:larger}
.small{font-size:smaller}
.underline{text-decoration:underline}
.overline{text-decoration:overline}
.line-through{text-decoration:line-through}
.aqua{color:#00bfbf}
.aqua-background{background:#00fafa}
.black{color:#000}
.black-background{background:#000}
.blue{color:#0000bf}
.blue-background{background:#0000fa}
.fuchsia{color:#bf00bf}
.fuchsia-background{background:#fa00fa}
.gray{color:#606060}
.gray-background{background:#7d7d7d}
.green{color:#006000}
.green-background{background:#007d00}
.lime{color:#00bf00}
.lime-background{background:#00fa00}
.maroon{color:#600000}
.maroon-background{background:#7d0000}
.navy{color:#000060}
.navy-background{background:#00007d}
.olive{color:#606000}
.olive-background{background:#7d7d00}
.purple{color:#600060}
.purple-background{background:#7d007d}
.red{color:#bf0000}
.red-background{background:#fa0000}
.silver{color:#909090}
.silver-background{background:#bcbcbc}
.teal{color:#006060}
.teal-background{background:#007d7d}
.white{color:#bfbfbf}
.white-background{background:#fafafa}
.yellow{color:#bfbf00}
.yellow-background{background:#fafa00}
span.icon>.fa{cursor:default}
a span.icon>.fa{cursor:inherit}
.admonitionblock td.icon [class^="fa icon-"]{font-size:2.5em;text-shadow:1px 1px 2px rgba(0,0,0,.5);cursor:default}
.admonitionblock td.icon .icon-note::before{content:"\f05a";color:#19407c}
.admonitionblock td.icon .icon-tip::before{content:"\f0eb";text-shadow:1px 1px 2px rgba(155,155,0,.8);color:#111}
.admonitionblock td.icon .icon-warning::before{content:"\f071";color:#bf6900}
.admonitionblock td.icon .icon-caution::before{content:"\f06d";color:#bf3400}
.admonitionblock td.icon .icon-important::before{content:"\f06a";color:#bf0000}
.conum[data-value]{display:inline-block;color:#fff!important;background:rgba(0,0,0,.8);-webkit-border-radius:50%;border-radius:50%;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
.conum[data-value] *{color:#fff!important}
.conum[data-value]+b{display:none}
.conum[data-value]::after{content:attr(data-value)}
pre .conum[data-value]{position:relative;top:-.125em}
b.conum *{color:inherit!important}
.conum:not([data-value]):empty{display:none}
dt,th.tableblock,td.content,div.footnote{text-rendering:optimizeLegibility}
h1,h2,p,td.content,span.alt{letter-spacing:-.01em}
p strong,td.content strong,div.footnote strong{letter-spacing:-.005em}
p,blockquote,dt,td.content,span.alt{font-size:1.0625rem}
p{margin-bottom:1.25rem}
.sidebarblock p,.sidebarblock dt,.sidebarblock td.content,p.tableblock{font-size:1em}
.exampleblock>.content{background:#fffef7;border-color:#e0e0dc;-webkit-box-shadow:0 1px 4px #e0e0dc;box-shadow:0 1px 4px #e0e0dc}
.print-only{display:none!important}
@page{margin:1.25cm .75cm}
@media print{*{-webkit-box-shadow:none!important;box-shadow:none!important;text-shadow:none!important}
html{font-size:80%}
a{color:inherit!important;text-decoration:underline!important}
a.bare,a[href^="#"],a[href^="mailto:"]{text-decoration:none!important}
a[href^="http:"]:not(.bare)::after,a[href^="https:"]:not(.bare)::after{content:"(" attr(href) ")";display:inline-block;font-size:.875em;padding-left:.25em}
abbr[title]::after{content:" (" attr(title) ")"}
pre,blockquote,tr,img,object,svg{page-break-inside:avoid}
thead{display:table-header-group}
svg{max-width:100%}
p,blockquote,dt,td.content{font-size:1em;orphans:3;widows:3}
h2,h3,#toctitle,.sidebarblock>.content>.title{page-break-after:avoid}
#header,#content,#footnotes,#footer{max-width:none}
#toc,.sidebarblock,.exampleblock>.content{background:none!important}
#toc{border-bottom:1px solid #dddddf!important;padding-bottom:0!important}
body.book #header{text-align:center}
body.book #header>h1:first-child{border:0!important;margin:2.5em 0 1em}
body.book #header .details{border:0!important;display:block;padding:0!important}
body.book #header .details span:first-child{margin-left:0!important}
body.book #header .details br{display:block}
body.book #header .details br+span::before{content:none!important}
body.book #toc{border:0!important;text-align:left!important;padding:0!important;margin:0!important}
body.book #toc,body.book #preamble,body.book h1.sect0,body.book .sect1>h2{page-break-before:always}
.listingblock code[data-lang]::before{display:block}
#footer{padding:0 .9375em}
.hide-on-print{display:none!important}
.print-only{display:block!important}
.hide-for-print{display:none!important}
.show-for-print{display:inherit!important}}
@media print,amzn-kf8{#header>h1:first-child{margin-top:1.25rem}
.sect1{padding:0!important}
.sect1+.sect1{border:0}
#footer{background:none}
#footer-text{color:rgba(0,0,0,.6);font-size:.9em}}
@media amzn-kf8{#header,#content,#footnotes,#footer{padding:0}}
</style> 
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"> 
  <!--
  Copyright (c) 2010, 2022 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
--> 
  <style>
.menu, .submenu, .menuitem, .menuref {
    background-color: Menu;
}

.button {
    border: 1px solid ButtonFace;
    /*
    Styling too similar to a real button is considered bad practice, see https://github.com/asciidoctor/asciidoctor/issues/1881#issuecomment-250702085
    border: 2px outset ButtonFace;
    background-color: ButtonFace;
    */
    padding-left: 0.5ex;
    padding-right: 0.5ex;
    font-weight: normal;
    font-family: "Segoe UI","Open Sans","DejaVu Sans",sans-serif;
    white-space: nowrap;
}
.button:before {
    content: none !important;
}
.button:after {
    content: none !important;
}

#footer-text, #footer-text a {
    color: rgba(255,255,255,.8)
}

.toc-cur-page {
    font-weight: bold;
}
</style> 
 </head> 
 <body class="book toc2 toc-left"> 
  <div id="header">   
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="../..">Eclipse ESCET™ website</a></p> 
    <div id="toctitle">
     Eclipse ESCET™ development documentation (Incubation)
    </div> 
    <ul class="sectlevel1">
     <li><a href="../index.html">Home</a></li> 
     <li><a href="../index.html#eclipse-escet-development">Eclipse ESCET development</a> 
      <ul class="sectlevel2"> 
       <li><a href="../development/dev-list.html">The Eclipse ESCET dev-list</a></li> 
       <li><a href="../development/development-process.html">Development process</a></li> 
       <li><a href="../development/contributing.html">Contributing</a></li> 
       <li><a href="../development/issue-tracking.html">Issue tracking</a></li> 
       <li><a href="../development/dev-env-setup.html">Development environment setup</a></li> 
       <li><a href="../development/git-repo.html">Git repository</a></li> 
       <li><a href="../development/coding-standards.html">Coding standards</a></li> 
       <li><a href="../development/building-and-testing.html">Building and testing</a></li> 
       <li><a href="../development/release-process.html">Release process</a></li> 
       <li><a href="../development/third-party-tools.html">Third party tools</a></li> 
       <li><a href="../development/dependency-upgrades.html">Dependency upgrades</a></li> 
      </ul> </li> 
     <li><a href="../app-framework/index.html">Application framework</a> 
      <ul class="sectlevel2"> 
       <li><a href="../app-framework/introduction.html">Introduction</a></li> 
       <li><a href="../app-framework/standalone-vs-eclipse.html">Stand-alone execution versus Eclipse IDE</a></li> 
       <li><a href="../app-framework/application-class.html">The Application class</a></li> 
       <li><a href="../app-framework/exception-framework.html">The exception framework</a></li> 
       <li><a href="../app-framework/exit-codes.html">Exit codes</a></li> 
       <li><a href="../app-framework/io-framework.html">The I/O framework</a></li> 
       <li><a href="../app-framework/option-framework.html">The option framework</a></li> 
       <li><a href="../app-framework/compiler-framework.html">The compiler framework</a></li> 
       <li><a href="../app-framework/implement-your-application.html">How to implement your own application</a></li> 
       <li><a href="../app-framework/registration.html">Application registration</a></li> 
       <li><a href="../app-framework/execution.html">Execution</a></li> 
      </ul> </li> 
     <li><a href="../dsm/index.html">Design Structure Matrix (DSM) library</a> 
      <ul class="sectlevel2"> 
       <li><a href="../dsm/entrypoint.html">Code organization</a></li> 
       <li><a href="../dsm/algorithm.html">Algorithm and code</a></li> 
       <li><a href="../dsm/busdetection.html">Bus detection algorithms</a></li> 
       <li><a href="../dsm/references.html">References</a></li> 
      </ul> </li> 
     <li><a href="../multivalue/index.html">Multi-value Decision Diagrams library</a> 
      <ul class="sectlevel2"> 
       <li><a href="../multivalue/goals.html">Goals</a></li> 
       <li><a href="../multivalue/variables-and-relations.html">Variables and relations</a></li> 
       <li><a href="../multivalue/combining-relations.html">Combining relations</a></li> 
       <li><a href="../multivalue/computing.html">Computing</a></li> 
       <li><a href="../multivalue/practical-usage.html">Practical usage</a></li> 
      </ul> </li> 
     <li><a href="index.html">Rail diagram generator</a> 
      <ul class="sectlevel2"> 
       <li><a href="introduction.html">Introduction</a></li> 
       <li><a href="examples.html">Examples</a></li> 
       <li><a href="#" class="toc-cur-page">Customizing output</a></li> 
       <li><a href="commandline.html">Command-line arguments</a></li> 
       <li><a href="lexical-syntax.html">Lexical syntax</a></li> 
       <li><a href="grammar.html">Grammar</a></li> 
       <li><a href="debugging.html">Debugging</a></li> 
      </ul> </li> 
     <li><a href="../setext/index.html">SeText scanner/parser generator</a> 
      <ul class="sectlevel2"> 
       <li><a href="../setext/lexical-syntax.html">SeText lexical syntax</a></li> 
       <li><a href="../setext/specifying-lexical-syntax.html">Specifying lexical syntax using SeText</a></li> 
       <li><a href="../setext/regular-expressions.html">Regular expressions</a></li> 
       <li><a href="../setext/terminal-descriptions.html">Terminal descriptions</a></li> 
       <li><a href="../setext/imports.html">Imports</a></li> 
       <li><a href="../setext/scanner-hooks.html">Scanner hooks</a></li> 
       <li><a href="../setext/specifying-grammars.html">Specifying grammars using SeText</a></li> 
       <li><a href="../setext/parser-hooks.html">Parser hooks</a></li> 
       <li><a href="../setext/usage-hints.html">Usage hints</a></li> 
       <li><a href="../setext/generated-scanners-parsers.html">Generated scanners/parsers</a></li> 
       <li><a href="../setext/using-in-an-eclipse-plugin-project.html">Using SeText in an Eclipse Plug-in Project</a></li> 
       <li><a href="../setext/limitations.html">Limitations</a></li> 
      </ul> </li> 
     <li><a href="../legal.html">Legal</a></li> 
    </ul> 
   </div> 
  </div> 
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../index.html">Eclipse ESCET™ development documentation (Incubation)</a> &gt; 
    <a class="breadcrumb" href="index.html">Rail diagram generator</a> &gt; 
    <span class="breadcrumb">Customizing output</span>
   </div>         
   <h2 id="customizing-output"><a class="anchor" href="#"></a>Customizing output</h2> 
   <div class="paragraph"> 
    <p>The program can take a properties file to translate terminals and non-terminals. The same file can also contain settings to modify shape, color, fonts, and spacing of almost everything.</p> 
   </div> 
   <div class="sect3"> 
    <h3 id="syntax-of-the-properties-file"><a class="anchor" href="#syntax-of-the-properties-file"></a>Syntax of the properties file</h3> 
    <div class="paragraph"> 
     <p>The properties file used by the program is a normal Java properties file. Its syntax is described in the <a href="https://docs.oracle.com/en/java/javase/17/docs/api/java.base/java/util/Properties.html#load(java.io.Reader)">Java 17 API Specification</a>.</p> 
    </div> 
    <div class="paragraph"> 
     <p>In short:</p> 
    </div> 
    <div class="ulist"> 
     <ul> 
      <li> <p>It is a file format that consists of lines of text.</p> </li> 
      <li> <p>Empty lines are allowed and are skipped.</p> </li> 
      <li> <p>Lines beginning with <code>#</code> or <code>!</code> are considered to be comment lines and are ignored.</p> </li> 
      <li> <p>Data lines contain key/value pairs.</p> </li> 
      <li> <p>By convention, properties files use the <code>.props</code> extension to their name.</p> </li> 
     </ul> 
    </div> 
    <div class="paragraph"> 
     <p>Here, a key of a data line is a sequence of words, separated by a dot, for example, <code>terminal.token.Identifier</code>. The key is followed by an optional but recommended separator character, either <code>:</code> or <code>=</code>. The remainder of the line is the value part, where leading and trailing white space is removed.</p> 
    </div> 
    <div class="paragraph"> 
     <p>The properties file format uses <code>\</code> as continuation character to the next line and also as escape character.</p> 
    </div> 
   </div> 
   <div class="sect3"> 
    <h3 id="kinds-of-values"><a class="anchor" href="#kinds-of-values"></a>Kinds of values</h3> 
    <div class="paragraph"> 
     <p>In the tables below, the properties keys recognized by the program are listed along with an example and an expected value.</p> 
    </div> 
    <div class="paragraph"> 
     <p>This table lists the used expected values, and gives some more information about them.</p> 
    </div> 
    <table class="tableblock frame-all grid-all stretch"> 
     <colgroup> 
      <col style="width: 20%;"> 
      <col style="width: 20%;"> 
      <col style="width: 60%;"> 
     </colgroup> 
     <thead> 
      <tr> 
       <th class="tableblock halign-left valign-top">Type name</th> 
       <th class="tableblock halign-left valign-top">Examples</th> 
       <th class="tableblock halign-left valign-top">Description</th> 
      </tr> 
     </thead> 
     <tbody> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Boolean</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>yes</code>, `false'</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Boolean value to enable or disable a flag.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">RGB color</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>151 7 230</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Three integer numbers between <code>0</code> and <code>255</code> inclusive, separated by spaces.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>10</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer value, usually with ‘pixel’ unit.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font name</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>Serif</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Name of the font to use. The program currently supports the <code>Dialog</code>, <code>DialogInput</code>, <code>Monospaced</code>, <code>Serif</code>, and <code>SansSerif</code> fonts.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font height</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>12</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer number specifying the point size of the font.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font style</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>plain</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Style of the font. The program currently supports <code>plain</code>, <code>bold</code>, and <code>italics</code> styles.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Text</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>literal</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Arbitrary text to display for a token.</p></td> 
      </tr> 
     </tbody> 
    </table> 
   </div> 
   <div class="sect3"> 
    <h3 id="global-settings"><a class="anchor" href="#global-settings"></a>Global settings</h3> 
    <div class="paragraph"> 
     <p>The following settings affect background and the rail line.</p> 
    </div> 
    <table class="tableblock frame-all grid-all stretch"> 
     <colgroup> 
      <col style="width: 20%;"> 
      <col style="width: 20%;"> 
      <col style="width: 60%;"> 
     </colgroup> 
     <thead> 
      <tr> 
       <th class="tableblock halign-left valign-top">Property name</th> 
       <th class="tableblock halign-left valign-top">Value type</th> 
       <th class="tableblock halign-left valign-top">Description</th> 
      </tr> 
     </thead> 
     <tbody> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>diagram.background.color</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">RGB color</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Color of the background of the generated image.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>rail.linewidth</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Width of the rail line.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>rail.color</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">RGB color</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Color of the rail line.</p></td> 
      </tr> 
     </tbody> 
    </table> 
   </div> 
   <div class="sect3"> 
    <h3 id="diagram-settings"><a class="anchor" href="#diagram-settings"></a>Diagram settings</h3> 
    <div class="paragraph"> 
     <p>The diagram settings configure the global layout of an image. At the top is a header line with the name of the rule, below it are one or more railroad pictures with some additional rail at both ends.</p> 
    </div> 
    <table class="tableblock frame-all grid-all stretch"> 
     <colgroup> 
      <col style="width: 33.3333%;"> 
      <col style="width: 16.6666%;"> 
      <col style="width: 50.0001%;"> 
     </colgroup> 
     <thead> 
      <tr> 
       <th class="tableblock halign-left valign-top">Property name</th> 
       <th class="tableblock halign-left valign-top">Value type</th> 
       <th class="tableblock halign-left valign-top">Description</th> 
      </tr> 
     </thead> 
     <tbody> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>rule.padding.top</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space above the header line.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>rule.padding.left</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space left of the header line.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>rule.padding.bottom</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space between the last railroad picture and the bottom of the diagram.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>rule.padding.right</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Minimum amount of space right of the header line.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>rule.diagram.padding.top</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space above each railroad picture.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>rule.diagram.padding.left</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space left of each railroad picture.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>rule.diagram.lead.width</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Horizontal length of the rail line before the railroad picture.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>rule.diagram.trail.width</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Horizontal length of the rail line after the railroad picture.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>diagram-header.text.color</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">RGB color</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Color of the diagram header text.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>diagram-header.text.font</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font name</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font of the diagram header text.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>diagram-header.text.font.size</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font height</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font size in points of the diagram header text.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>diagram-header.text.font.style</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font style</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Style of the diagram header text.</p></td> 
      </tr> 
     </tbody> 
    </table> 
   </div> 
   <div class="sect3"> 
    <h3 id="empty-node"><a class="anchor" href="#empty-node"></a>Empty node</h3> 
    <div class="paragraph"> 
     <p>Each kind of node has a number of settings as well, starting with the simplest node, <code>()</code>.</p> 
    </div> 
    <table class="tableblock frame-all grid-all stretch"> 
     <colgroup> 
      <col style="width: 33.3333%;"> 
      <col style="width: 16.6666%;"> 
      <col style="width: 50.0001%;"> 
     </colgroup> 
     <thead> 
      <tr> 
       <th class="tableblock halign-left valign-top">Property name</th> 
       <th class="tableblock halign-left valign-top">Value type</th> 
       <th class="tableblock halign-left valign-top">Description</th> 
      </tr> 
     </thead> 
     <tbody> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>empty.width</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Horizontal length of the empty node.</p></td> 
      </tr> 
     </tbody> 
    </table> 
   </div> 
   <div class="sect3"> 
    <h3 id="branch-label"><a class="anchor" href="#branch-label"></a>Branch label</h3> 
    <div class="paragraph"> 
     <p>The bracketed string <code>[refname]</code> node configuration settings are listed below.</p> 
    </div> 
    <table class="tableblock frame-all grid-all stretch"> 
     <colgroup> 
      <col style="width: 33.3333%;"> 
      <col style="width: 16.6666%;"> 
      <col style="width: 50.0001%;"> 
     </colgroup> 
     <thead> 
      <tr> 
       <th class="tableblock halign-left valign-top">Property name</th> 
       <th class="tableblock halign-left valign-top">Value type</th> 
       <th class="tableblock halign-left valign-top">Description</th> 
      </tr> 
     </thead> 
     <tbody> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>branch-label.padding.left</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space at the left of the label text.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>branch-label.padding.right</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space at the right of the label text.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>branch-label.padding.top</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space above the label text.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>branch-label.padding.bottom</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space between the label text and the rail line.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>branch-label.min-width</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Minimum horizontal length of the label node.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>branch-label.text.color</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">RGB color</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Color of the label text.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>branch-label.text.font</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font name</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font used for the label text.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>branch-label.text.font.size</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font height</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font size in pt of the label text.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>branch-label.text.font.style</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font style</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Font style of the label text.</p></td> 
      </tr> 
     </tbody> 
    </table> 
   </div> 
   <div class="sect3"> 
    <h3 id="name-node"><a class="anchor" href="#name-node"></a>Name node</h3> 
    <div class="paragraph"> 
     <p>A name node is a string of text within a box. The text is often a single name, and the box may have rounded corners. At the left and right of the box, a rail line is connected.</p> 
    </div> 
    <div class="paragraph"> 
     <p>First the configuration of the rail lines, followed by the configuration settings of the box and the text.</p> 
    </div> 
    <table class="tableblock frame-all grid-all stretch"> 
     <colgroup> 
      <col style="width: 33.3333%;"> 
      <col style="width: 16.6666%;"> 
      <col style="width: 50.0001%;"> 
     </colgroup> 
     <thead> 
      <tr> 
       <th class="tableblock halign-left valign-top">Property name</th> 
       <th class="tableblock halign-left valign-top">Value type</th> 
       <th class="tableblock halign-left valign-top">Description</th> 
      </tr> 
     </thead> 
     <tbody> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>name.rail.entry.width</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Horizontal length of the rail line at the left of the box.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>name.rail.exit.width</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Horizontal length of the rail line at the right of the box.</p></td> 
      </tr> 
     </tbody> 
    </table> 
    <div class="paragraph"> 
     <p>There are three configurations for name and box. One for terminals, one for meta-terminals, and one for non-terminals. The structure of the settings is the same for all three, their default values are a little different, in particular in choices of corner radius and font.</p> 
    </div> 
    <div class="sect4"> 
     <h4 id="terminal-text-and-box-properties"><a class="anchor" href="#terminal-text-and-box-properties"></a>Terminal text and box properties</h4> 
     <table class="tableblock frame-all grid-all stretch"> 
      <colgroup> 
       <col style="width: 33.3333%;"> 
       <col style="width: 16.6666%;"> 
       <col style="width: 50.0001%;"> 
      </colgroup> 
      <thead> 
       <tr> 
        <th class="tableblock halign-left valign-top">Property name</th> 
        <th class="tableblock halign-left valign-top">Value type</th> 
        <th class="tableblock halign-left valign-top">Description</th> 
       </tr> 
      </thead> 
      <tbody> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>terminal.name.padding.horizontal</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of horizontal space between the text and the box around the text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>terminal.name.padding.vertical</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of vertical space between the text and the box around the text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>terminal.corner.radius</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Radius of the corners of the box. <code>0</code> means a rectangular box.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>terminal.box.color</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">RGB color</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Color of the line of the box.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>terminal.box.linewidth</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Width of the line of the box.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>terminal.text.color</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">RGB color</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Color of the terminal text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>terminal.text.font</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font name</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font used for the terminal text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>terminal.text.font.size</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font height</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Height of the terminal text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>terminal.text.font.style</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font style</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Style of the terminal text.</p></td> 
       </tr> 
      </tbody> 
     </table> 
    </div> 
    <div class="sect4"> 
     <h4 id="meta-terminal-text-and-box-properties"><a class="anchor" href="#meta-terminal-text-and-box-properties"></a>Meta-terminal text and box properties</h4> 
     <table class="tableblock frame-all grid-all stretch"> 
      <colgroup> 
       <col style="width: 33.3333%;"> 
       <col style="width: 16.6666%;"> 
       <col style="width: 50.0001%;"> 
      </colgroup> 
      <thead> 
       <tr> 
        <th class="tableblock halign-left valign-top">Property name</th> 
        <th class="tableblock halign-left valign-top">Value type</th> 
        <th class="tableblock halign-left valign-top">Description</th> 
       </tr> 
      </thead> 
      <tbody> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>meta-terminal.name.padding.horizontal</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of horizontal space between the text and the box around the text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>meta-terminal.name.padding.vertical</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of vertical space between the text and the box around the text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>meta-terminal.corner.radius</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Radius of the corners of the box. <code>0</code> means a rectangular box.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>meta-terminal.box.color</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">RGB color</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Color of the line of the box.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>meta-terminal.box.linewidth</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Width of the line of the box.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>meta-terminal.text.color</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">RGB color</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Color of the meta-terminal text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>meta-terminal.text.font</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font name</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font used for the meta-terminal text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>meta-terminal.text.font.size</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font height</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Height of the meta-terminal text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>meta-terminal.text.font.style</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font style</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Style of the meta-terminal text.</p></td> 
       </tr> 
      </tbody> 
     </table> 
    </div> 
    <div class="sect4"> 
     <h4 id="non-terminal-text-and-box-properties"><a class="anchor" href="#non-terminal-text-and-box-properties"></a>Non-terminal text and box properties</h4> 
     <table class="tableblock frame-all grid-all stretch"> 
      <colgroup> 
       <col style="width: 33.3333%;"> 
       <col style="width: 16.6666%;"> 
       <col style="width: 50.0001%;"> 
      </colgroup> 
      <thead> 
       <tr> 
        <th class="tableblock halign-left valign-top">Property name</th> 
        <th class="tableblock halign-left valign-top">Value type</th> 
        <th class="tableblock halign-left valign-top">Description</th> 
       </tr> 
      </thead> 
      <tbody> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>nonterminal.name.padding.horizontal</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of horizontal space between the text and the box around the text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>nonterminal.name.padding.vertical</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of vertical space between the text and the box around the text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>nonterminal.corner.radius</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Radius of the corners of the box. <code>0</code> means a rectangular box.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>nonterminal.box.color</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">RGB color</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Color of the line of the box.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>nonterminal.box.linewidth</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Width of the line of the box.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>nonterminal.text.color</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">RGB color</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Color of the non-terminal text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>nonterminal.text.font</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font name</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font used for the non-terminal text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>nonterminal.text.font.size</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font height</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Height of the non-terminal text.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>nonterminal.text.font.style</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Font style</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Style of the non-terminal text.</p></td> 
       </tr> 
      </tbody> 
     </table> 
    </div> 
    <div class="sect4"> 
     <h4 id="token-text-translations"><a class="anchor" href="#token-text-translations"></a>Token text translations</h4> 
     <div class="paragraph"> 
      <p>In the diagram input files, token names may be used, but terminals often contain other symbols. The translation between the token name and the text it should display can also be configured.</p> 
     </div> 
     <div class="paragraph"> 
      <p>There are three groups of settings. Different settings within a group only differ in the name of the token that they translate. Such a name is listed here as <code>&lt;token-name&gt;</code>.</p> 
     </div> 
     <table class="tableblock frame-all grid-all stretch"> 
      <colgroup> 
       <col style="width: 28.5714%;"> 
       <col style="width: 14.2857%;"> 
       <col style="width: 57.1429%;"> 
      </colgroup> 
      <thead> 
       <tr> 
        <th class="tableblock halign-left valign-top">Property name</th> 
        <th class="tableblock halign-left valign-top">Value type</th> 
        <th class="tableblock halign-left valign-top">Description</th> 
       </tr> 
      </thead> 
      <tbody> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>terminal.token.&lt;token-name&gt;</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Text</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">The literal text to display in the diagram for terminal token <code>&lt;token-name&gt;</code>.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>meta-terminal.&lt;token-name&gt;</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Text</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">The literal text to display in the diagram for meta-terminal token <code>&lt;token-name&gt;</code>.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>nonterminal.token.&lt;token-name&gt;</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Text</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">The literal text to display in the diagram for non-terminal token <code>&lt;token-name&gt;</code>.</p></td> 
       </tr> 
      </tbody> 
     </table> 
     <div class="paragraph"> 
      <p>All tokens must have a different name. Both terminals and meta-terminals token lists are assumed to be complete. The non-terminal list is fully optional, and the default choice if a token name cannot be found. All missing entries use the token name as their text.</p> 
     </div> 
     <div class="paragraph"> 
      <p>Note that the property file reader applies some interpretation to the text as well so what you enter in the file may not be what you get. Please check the <a href="#syntax-of-the-properties-file">property file syntax</a> section for details.</p> 
     </div> 
    </div> 
   </div> 
   <div class="sect3"> 
    <h3 id="sequence"><a class="anchor" href="#sequence"></a>Sequence</h3> 
    <div class="paragraph"> 
     <p>A sequence connects one or more child diagram nodes in one or more rows such that they are all visited in sequential order.</p> 
    </div> 
    <div class="paragraph"> 
     <p>Its configuration settings cover the elements around the child nodes.</p> 
    </div> 
    <table class="tableblock frame-all grid-all stretch"> 
     <colgroup> 
      <col style="width: 33.3333%;"> 
      <col style="width: 16.6666%;"> 
      <col style="width: 50.0001%;"> 
     </colgroup> 
     <thead> 
      <tr> 
       <th class="tableblock halign-left valign-top">Property name</th> 
       <th class="tableblock halign-left valign-top">Value type</th> 
       <th class="tableblock halign-left valign-top">Description</th> 
      </tr> 
     </thead> 
     <tbody> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>sequence.padding.first-row.prefix</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space before the first child at the first row.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>sequence.padding.other-row.prefix</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space left of the left connecting vertical line to a next row.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>sequence.padding.row.suffix</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">If there is more than one row, the minimal amount of space between the right vertical line connecting a next row, and the vertical line up to the exit.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>sequence.padding.interrow</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Minimal amount of space between the bottom of a row, and the connecting horizontal line to the next row beneath it. Also, the minimal amount of space between the same horizontal line and the top of the next row.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>sequence.arc-radius</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Radius of the arcs connecting horizontal lines with vertical lines.</p></td> 
      </tr> 
     </tbody> 
    </table> 
   </div> 
   <div class="sect3"> 
    <h3 id="choice"><a class="anchor" href="#choice"></a>Choice</h3> 
    <div class="paragraph"> 
     <p>The choice node expresses a choice between one of the child diagram nodes.</p> 
    </div> 
    <div class="paragraph"> 
     <p>Its configurable properties are:</p> 
    </div> 
    <table class="tableblock frame-all grid-all stretch"> 
     <colgroup> 
      <col style="width: 33.3333%;"> 
      <col style="width: 16.6666%;"> 
      <col style="width: 50.0001%;"> 
     </colgroup> 
     <thead> 
      <tr> 
       <th class="tableblock halign-left valign-top">Property name</th> 
       <th class="tableblock halign-left valign-top">Value type</th> 
       <th class="tableblock halign-left valign-top">Description</th> 
      </tr> 
     </thead> 
     <tbody> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>choice.arc-radius</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Radius of the arcs connecting horizontal lines with vertical lines.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>choice.padding.vertical</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Minimal amount of vertical space between two child diagrams.</p></td> 
      </tr> 
     </tbody> 
    </table> 
    <div class="paragraph"> 
     <p>Note that the space between the first and second child is not only influenced by the <code>choice.padding.vertical</code> setting, but also influenced by the <code>choice.arc-radius</code>, as two arcs have to fit vertically as well.</p> 
    </div> 
   </div> 
   <div class="sect3"> 
    <h3 id="repetition"><a class="anchor" href="#repetition"></a>Repetition</h3> 
    <div class="paragraph"> 
     <p>The repetition node <code>A + B</code> expresses an alternating execution sequence <code>A(BA)*</code>. The <code>A</code> child node is referred to as <em>forward</em>, as its execution runs normally from left to right in the diagram, while the <code>B</code> child is referred to as <em>backward</em> as its execution normally runs from right to left. The repetition is also known as <em>loop</em> due to the circular shape of the node.</p> 
    </div> 
    <div class="paragraph"> 
     <p>Its configuration settings are:</p> 
    </div> 
    <table class="tableblock frame-all grid-all stretch"> 
     <colgroup> 
      <col style="width: 33.3333%;"> 
      <col style="width: 16.6666%;"> 
      <col style="width: 50.0001%;"> 
     </colgroup> 
     <thead> 
      <tr> 
       <th class="tableblock halign-left valign-top">Property name</th> 
       <th class="tableblock halign-left valign-top">Value type</th> 
       <th class="tableblock halign-left valign-top">Description</th> 
      </tr> 
     </thead> 
     <tbody> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>loop.arc-radius</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Radius of the arcs connecting horizontal lines with vertical lines.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>loop.padding.vertical</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of vertical space between the nodes of the forward and backward sequences.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>loop.padding.left</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space left of the left vertical line.</p></td> 
      </tr> 
      <tr> 
       <td class="tableblock halign-left valign-top"><p class="tableblock"><code>loop.padding.right</code></p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Integer</p></td> 
       <td class="tableblock halign-left valign-top"><p class="tableblock">Amount of space right of the right vertical line.</p></td> 
      </tr> 
     </tbody> 
    </table> 
    <div class="paragraph"> 
     <p>The <code>loop.padding.left</code> and <code>loop.padding.right</code> become important when a diagram contains a sequence of repetitions. If you set the left and right padding to <code>0</code>, the following may happen:</p> 
    </div> 
    <div class="listingblock"> 
     <div class="content"> 
      <pre class="highlight"><code class="language-raildiagram" data-lang="raildiagram">SequenceLoops : (A + B) (C + D) ;</code></pre> 
     </div> 
    </div> 
    <div class="paragraph"> 
     <p>This results in:</p> 
    </div> 
    <div class="imageblock"> 
     <div class="content"> 
      <img src="sequence_loops.rr.png" alt="Sequence of loops"> 
     </div> 
    </div> 
    <div class="paragraph"> 
     <p>Other nodes all have some space at either end, making it less apparent in those cases.</p> 
    </div> 
   </div> 
   <div class="sect3"> 
    <h3 id="debugging-properties"><a class="anchor" href="#debugging-properties"></a>Debugging properties</h3> 
    <div class="paragraph"> 
     <p>A diagram is actually a tree of simpler diagrams where at each node in the tree a set of position equations is solved for positioning all elements in its sub-tree. This happens in two sweeps through the tree. First a bottom-up computation of size and relative position of elements in their sub-tree is performed. In the second top-down sweep assignment of horizontal and vertical absolute offsets to all nodes is performed, giving all elements their final absolute position in the diagram. Output is produced by a walk over all nodes in the tree, and copying the elements with their absolute positions to the output.</p> 
    </div> 
    <div class="paragraph"> 
     <p>There are several flags for generating detailed output of the above process to support debugging at several points in the computations.</p> 
    </div> 
    <div class="sect4"> 
     <h4 id="hierarchy"><a class="anchor" href="#hierarchy"></a>Hierarchy</h4> 
     <div class="paragraph"> 
      <p>To view the tree hierarchy in the diagram, the <code>debug.structure</code> flag can be used.</p> 
     </div> 
     <table class="tableblock frame-all grid-all stretch"> 
      <colgroup> 
       <col style="width: 33.3333%;"> 
       <col style="width: 16.6666%;"> 
       <col style="width: 50.0001%;"> 
      </colgroup> 
      <thead> 
       <tr> 
        <th class="tableblock halign-left valign-top">Property name</th> 
        <th class="tableblock halign-left valign-top">Value type</th> 
        <th class="tableblock halign-left valign-top">Description</th> 
       </tr> 
      </thead> 
      <tbody> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>debug.structure</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Boolean</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Dump internal structure of the diagram.</p></td> 
       </tr> 
      </tbody> 
     </table> 
    </div> 
    <div class="sect4"> 
     <h4 id="constraint-solving"><a class="anchor" href="#constraint-solving"></a>Constraint solving</h4> 
     <div class="paragraph"> 
      <p>Positions are computed by solving two sets of constraint equations at each node in the tree, one for horizontal positioning, and one for vertical positioning. The <code>debug.equations</code> flag shows the variables and equations, the <code>debug.solver</code> shows the solving process. Due to the large number of variables and equations in a typical diagram, enabling these settings produces a lot of detailed debug output.</p> 
     </div> 
     <table class="tableblock frame-all grid-all stretch"> 
      <colgroup> 
       <col style="width: 33.3333%;"> 
       <col style="width: 16.6666%;"> 
       <col style="width: 50.0001%;"> 
      </colgroup> 
      <thead> 
       <tr> 
        <th class="tableblock halign-left valign-top">Property name</th> 
        <th class="tableblock halign-left valign-top">Value type</th> 
        <th class="tableblock halign-left valign-top">Description</th> 
       </tr> 
      </thead> 
      <tbody> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>debug.equations</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Boolean</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Dump positioning equations for the graphical elements.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>debug.solver</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Boolean</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Dump reasoning and deciding edge position values for the graphical elements.</p></td> 
       </tr> 
      </tbody> 
     </table> 
    </div> 
    <div class="sect4"> 
     <h4 id="coordinates"><a class="anchor" href="#coordinates"></a>Coordinates</h4> 
     <div class="paragraph"> 
      <p>To debug problems in produced output, the following flags are useful. The <code>debug.rel_coordinates</code> flag shows position information at each level of the tree separately, this is mostly useful to find problems at a single level of a diagram. The <code>debug.abs_coordinates</code> flag shows the same position information, except all coordinates use the same top-left origin, enabling verification of positions between different levels in the hierarchy.</p> 
     </div> 
     <table class="tableblock frame-all grid-all stretch"> 
      <colgroup> 
       <col style="width: 33.3333%;"> 
       <col style="width: 16.6666%;"> 
       <col style="width: 50.0001%;"> 
      </colgroup> 
      <thead> 
       <tr> 
        <th class="tableblock halign-left valign-top">Property name</th> 
        <th class="tableblock halign-left valign-top">Value type</th> 
        <th class="tableblock halign-left valign-top">Description</th> 
       </tr> 
      </thead> 
      <tbody> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>debug.rel_coordinates</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Boolean</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Dump coordinates of the graphical elements and child node positions within each element.</p></td> 
       </tr> 
       <tr> 
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>debug.abs_coordinates</code></p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Boolean</p></td> 
        <td class="tableblock halign-left valign-top"><p class="tableblock">Dump absolute coordinates of the graphical elements and child node positions of the diagram.</p></td> 
       </tr> 
      </tbody> 
     </table> 
     <div class="paragraph"> 
      <p>Note that positions are stated as inclusive horizontal and vertical edge positions everywhere. This means that element <code>x[1—​1], y[1—​2]</code> is one unit wide horizontally, and two units vertically. Also, an element <code>x[2—​7], y[1—​2]</code> is directly next to the previous element, there is no space between them. Zero width or height is shown as an interval with the first value larger than the second value, for example <code>x[4—​3]</code>.</p> 
     </div> 
    </div> 
   </div> 
   <div class="sect3"> 
    <h3 id="default-property-values"><a class="anchor" href="#default-property-values"></a>Default property values</h3> 
    <div class="paragraph"> 
     <p>The default values for the various properties are as follows:</p> 
    </div> 
    <div class="listingblock"> 
     <div class="content"> 
      <pre class="highlight"><code class="language-properties" data-lang="properties"># Background.
diagram.background.color: 255 255 255

# Rail.
rail.linewidth: 1.0
rail.color:     0 0 0

# Diagram rule.
rule.padding.top:          10
rule.padding.left:         10
rule.padding.bottom:       10
rule.padding.right:        10
rule.diagram.padding.top:  10
rule.diagram.padding.left: 10
rule.diagram.lead.width:   20
rule.diagram.trail.width:  20

# Choice.
choice.arc-radius:       10
choice.padding.vertical:  5

# Loop.
loop.arc-radius:       10
loop.padding.vertical:  5
loop.padding.left:      5
loop.padding.right:     5

# Sequence.
sequence.padding.first-row.prefix:  0
sequence.padding.other-row.prefix:  5
sequence.padding.row.suffix:        5
sequence.padding.interrow:          8
sequence.arc-radius:               10

# Branch label.
branch-label.padding.left:    5
branch-label.padding.right:   5
branch-label.padding.top:     5
branch-label.padding.bottom:  5
branch-label.min-width:       5
branch-label.text.color:      0 0 0
branch-label.text.font:       SansSerif
branch-label.text.font.size:  16
branch-label.text.font.style: plain

# Empty node.
empty.width: 10

# Name node, width of the entry and exit connections.
name.rail.entry.width: 5
name.rail.exit.width:  5

# Header font and text.
diagram-header.text.color:      0 0 0
diagram-header.text.font:       SansSerif
diagram-header.text.font.size:  16
diagram-header.text.font.style: bold

# 'terminal' name properties.
terminal.name.padding.horizontal: 5
terminal.name.padding.vertical:   5
terminal.corner.radius:           12
terminal.box.color:               0 0 0
terminal.box.linewidth:           1.0
terminal.text.color:              0 0 0
terminal.text.font:               Monospaced
terminal.text.font.size:          18
terminal.text.font.style:         plain

# 'meta-terminal' name properties.
meta-terminal.name.padding.horizontal: 5
meta-terminal.name.padding.vertical:   5
meta-terminal.corner.radius:           12
meta-terminal.box.color:               0 0 0
meta-terminal.box.linewidth:           1.0
meta-terminal.text.color:              0 0 0
meta-terminal.text.font:               SansSerif
meta-terminal.text.font.size:          16
meta-terminal.text.font.style:         plain

# 'nonterminal' name properties.
nonterminal.name.padding.horizontal: 5
nonterminal.name.padding.vertical:   5
nonterminal.corner.radius:           0
nonterminal.box.color:               0 0 0
nonterminal.box.linewidth:           1.0
nonterminal.text.color:              0 0 0
nonterminal.text.font:               SansSerif
nonterminal.text.font.size:          16
nonterminal.text.font.style:         italic

# Token text properties:
# terminal.token.&lt;tokname&gt;: &lt;toktext&gt;, should always be fully specified.
# meta-terminal.&lt;tokname&gt;: &lt;toktext&gt;, should always be fully specified.
# nonterminal.token.&lt;tokname&gt;: &lt;toktext&gt;, with &lt;toktext&gt; optional, default value is &lt;tokname&gt;.

# Debugging support, ordered by topic.
debug.structure:       false
debug.equations:       false
debug.solver:          false
debug.rel_coordinates: false
debug.abs_coordinates: false</code></pre> 
     </div> 
    </div> 
   </div> 
  </div> 
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script> 
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script> 
  <!--
  Copyright (c) 2010, 2022 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
--> 
  <div id="footer"> 
   <div id="footer-text">
    <span>Eclipse ESCET™ development documentation (Incubation)</span> | 
    <span>Copyright (c) 2010, 2022 Contributors to the Eclipse Foundation</span> | 
    <span>version v0.8</span>
    <br> 
    <a href="https://www.eclipse.org">Eclipse Home</a> | 
    <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | 
    <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | 
    <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | 
    <a href="https://www.eclipse.org/legal">Eclipse Legal</a> 
   </div> 
  </div>  
 </body>
</html>